# -*- coding: utf-8 -*-
"""
Created on Fri Sep 20 13:34:18 2019

@author: iryolab
"""

import pandas as pd
import os
import numpy as np
import matplotlib.pyplot as plt
import os
os.chdir(r"E:\rescue")



def make_ava_id_list(mode_name, df):
    ava_id_list = []
    for a, b in df.groupby(by = "ユーザーコード"):
        ava_count = 0
        for key,row in b.iterrows():
            if mode_name in row.values:
                ava_count += 1
        if ava_count >= 1:
            ava_id_list.append(a)
    
    return ava_id_list


def car_bicycle_avail_flag(id_series, ava_id_list):    
    availability_flag_list = []
    for i in id_series:
        if i in ava_id_list:        
            availability_flag_list.append(1)
        else:
            availability_flag_list.append(0)
    return availability_flag_list


def bus_avail_flag(ttime_series):
    if ttime_series == -1:
        ava_flag = 0
    else:
        ava_flag = 1
    return ava_flag


def train_avail_flag(ttime_series):
    if ttime_series == -999:
        ava_flag = 0
    else:
        ava_flag = 1
    return ava_flag


def sharecycle_avail_flag(acc_port_distance, egr_port_distance):
    if (acc_port_distance >= 3000) | (egr_port_distance >= 3000):
        ava_flag = 0
    else:
        ava_flag = 1
    return ava_flag


df_availability = pd.read_csv("rescue_egr_acc_sharebike_trip_toyosu2018.csv", encoding = "cp932")

df_availability["taxi_ava"] = np.ones(len(df_availability)).astype(int)

df_availability["walk_ava"] = np.ones(len(df_availability)).astype(int)


bicycle_ava_id_list = make_ava_id_list("自転車", df_availability)
df_availability["bicycle_ava"] = car_bicycle_avail_flag(df_availability["ユーザーコード"].values, bicycle_ava_id_list)

car_ava_id_list = make_ava_id_list("乗用車", df_availability)
df_availability["car_ava"] = car_bicycle_avail_flag(df_availability["ユーザーコード"].values, car_ava_id_list)

df_availability["bus_ava"] = list(map(bus_avail_flag, df_availability["bus_ttime"].values))

df_availability["train_ava"] = list(map(train_avail_flag, df_availability["train_ttime"].values))

df_availability["sharecycle_ava"] = np.vectorize(sharecycle_avail_flag)(df_availability["acc_sharebike_walk_distance"], df_availability["egr_sharebike_walk_distance"])

def name_change(name):
    if type(name) == int:
        print(name)
        
    
    elif "黎" in name:
        name = name.replace("黎","れい") 
    elif "－" in name:
        name = name.replace("－"," ") 
    
    elif "Ⅰ" in name:
        name = name.replace("Ⅰ","1")
        
    elif "②" in name:
        name = name.replace("②","2")
        
    elif "é" in name:
        name = name.replace("é","e")
        
    elif "①" in name:
        name = name.replace("①", "1")
        
    elif "－" in name:
        name = name.replace("－"," ") 
        
    elif "Ⅰ" in name:
        name = name.replace("Ⅰ","1")
        
    elif "②" in name:
        name = name.replace("②","2")
       
#    elif "C" in name:
#        name = name.replace("C", "c")
   
    return name

df_availability["dep_sharebike_name"] = list(map(name_change, df_availability["dep_sharebike_name"]))

df_availability["dest_sharebike_name"] = list(map(name_change, df_availability["dest_sharebike_name"]))


test = df_availability.iloc[100:,:]










df_availability.to_csv("rescue_ava_cleaned_trip_toyosu2018.csv", index = False, encoding = "cp932") 


