# -*- coding: utf-8 -*-
"""
Created on Thu Sep 19 22:04:39 2019

@author: Ikeda Kenji
"""

import pandas as pd
import os
import googlemaps
import numpy as np

gmaps = googlemaps.Client(key='')###key変える

os.chdir(r"C:\Users\Ikeda Kenji\Desktop\夏の学校2019")


def get_duration(dest_lat, dest_lng):
    

    # 住所から緯度経度を取得する
#    geocode_result = gmaps.geocode(lat, lon)
#    dest_lat = geocode_result[0]['geometry']['location']['lat'] # 緯度
#    dest_lng = geocode_result[0]['geometry']['location']['lng'] # 経度

    # 最寄り駅の緯度経度を取得
    places_result = gmaps.places_nearby(location=(dest_lat, dest_lng), type='transit_station', 
                                        rank_by='distance', language = "ja")
    dep_lat = places_result['results'][0]['geometry']['location']['lat'] # 緯度
    dep_lng = places_result['results'][0]['geometry']['location']['lng'] # 経度
    
    station_name = places_result['results'][0]['name']

    # 所要時間の取得
    walk_duration_result = gmaps.distance_matrix(origins=(dep_lat, dep_lng), destinations=(dest_lat, dest_lng),
                                            mode='walking')
    walk_duration = walk_duration_result['rows'][0]['elements'][0]['duration']['value'] / 60
    walk_distance = walk_duration_result['rows'][0]['elements'][0]["distance"]["value"]
    
    bicycle_duration = ((walk_distance/1000) / 12) * 60
    
    car_duration_result = gmaps.distance_matrix(origins=(dep_lat, dep_lng), destinations=(dest_lat, dest_lng),
                                            mode='driving')
    car_duration = car_duration_result['rows'][0]['elements'][0]['duration']['value'] / 60
    car_distance = car_duration_result['rows'][0]['elements'][0]["distance"]["value"]
    
    if car_distance <= 1052:               
        result_taxi_cost = 410                 
    else:        
        result_taxi_cost = 410 + (int((car_distance - 1052) / 237) + 1) * 80 
        
    address_result = gmaps.reverse_geocode((dep_lat, dep_lng), language = "ja")    
    address = address_result[0]["formatted_address"].split(" ")[-1]
    
    return dep_lat, dep_lng, station_name, address, walk_duration, walk_distance, bicycle_duration, car_duration, car_distance, result_taxi_cost



#dep_lat, dep_lng, station_name, address, walk_duration, walk_distance, bicycle_duration, car_duration, car_distance, result_taxi_cost = get_duration(34.726478, 135.237911)


df_car_cleaned = pd.read_csv("rescue.csv", engine = "python", encoding = "shift-JIS")

import time

start = time.time()


result_dep_lat_list = []    
result_dep_lng_list = []
result_station_name_list = []
result_address_list = []    
result_walk_duration_list = []
result_walk_distance_list = []
result_bicycle_duration_list = []    
result_car_duration_list = []
result_car_distance_list = []
result_taxi_cost_list = []
error_key_list = []

UnboundLocalError_count = 0
KeyError_count = 0
IndexError_count = 0
    
for key,row in df_car_cleaned.iterrows():

    #出発地、目的地を入力
    dest_lat = str(row["出発地施設緯度（世界測地系）"])
    
    dest_lng = str(row["出発地施設経度（世界測地系）"])
    
    try:
    
        dep_lat, dep_lng, station_name, address, walk_duration, walk_distance, bicycle_duration, car_duration, car_distance, result_taxi_cost = get_duration(dest_lat, dest_lng)
        
    except UnboundLocalError:
        
        dep_lat, dep_lng, station_name, address, walk_duration, walk_distance, bicycle_duration, car_duration, car_distance, result_taxi_cost = (-9999, -9999, -9999,-9999, -9999, -9999,-9999, -9999, -9999,-9999)
        
        error_key_list.append(key)
        
        UnboundLocalError_count += 1
        
    except KeyError:
        
        dep_lat, dep_lng, station_name, address, walk_duration, walk_distance, bicycle_duration, car_duration, car_distance, result_taxi_cost = (-9999, -9999, -9999,-9999, -9999, -9999,-9999, -9999, -9999,-9999)
        
        error_key_list.append(key)
        
        KeyError_count += 1
        
    except IndexError:
        
        dep_lat, dep_lng, station_name, address, walk_duration, walk_distance, bicycle_duration, car_duration, car_distance, result_taxi_cost = (-9999, -9999, -9999,-9999, -9999, -9999,-9999, -9999, -9999,-9999)
        
        error_key_list.append(key)
        
        IndexError_count += 1
        
    
    result_dep_lat_list.append(dep_lat)
    result_dep_lng_list.append(dep_lng)
    result_station_name_list.append(station_name)
    result_address_list.append(address)   
    result_walk_duration_list.append(walk_duration)
    result_walk_distance_list.append(walk_distance)
    result_bicycle_duration_list.append(bicycle_duration)    
    result_car_duration_list.append(car_duration)
    result_car_distance_list.append(car_distance)
    result_taxi_cost_list.append(result_taxi_cost)
    
      
    
end = time.time()

print(end-start) 


df_car_cleaned["dep_bus_lat"] = result_dep_lat_list
df_car_cleaned["dep_bus_lon"] = result_dep_lng_list
df_car_cleaned["dep_bus_name"] = result_station_name_list
df_car_cleaned["dep_bus_address"] = result_address_list
df_car_cleaned["acc_bus_walk_ttime"] = result_walk_duration_list
df_car_cleaned["acc_bus_walk_distance"] = result_walk_distance_list
df_car_cleaned["acc_bus_bicycle_ttime"] = result_bicycle_duration_list
df_car_cleaned["acc_bus_car_ttime"] = result_car_duration_list
df_car_cleaned["acc_bus_car_distance"] = result_car_distance_list
df_car_cleaned["acc_bus_taxi_cost"] = result_taxi_cost_list


df_car_cleaned.to_csv("rescue_acc_bus_trip_toyosu2018.csv", index = False,encoding = "shift-jis")


result_DF = pd.DataFrame(np.array([result_dep_lat_list, result_dep_lng_list, result_station_name_list, result_address_list, result_walk_duration_list,
                                   result_walk_distance_list, result_bicycle_duration_list, result_car_duration_list, result_car_distance_list, result_taxi_cost_list]).T,
                         columns = ["dep_bus_lat","dep_bus_lon","dep_bus_name","dep_bus_address","acc_bus_walk_ttime",
                                    "acc_bus_walk_distance", "acc_bus_bicycle_ttime", "acc_bus_car_ttime", "acc_bus_car_distance", "acc_bus_taxi_cost"])

result_DF.to_csv("rescue_acc_bus.csv", index = False, encoding = "shift-jis")
    
    
error_key_series = pd.Series(error_key_list)
error_key_series.to_csv("rescue_acc_bus_error_key_list.csv", index = False)



#copy_df_car_cleaned = df_car_cleaned.copy()
#
##dfdfdf = copy_df_car_cleaned[3992:]
##
##dfdfdf.to_csv("dfdfdf_acc_bus_trip_toyosu2018.csv", index = False, encoding = "shift-jis")
#
#copy_df_car_cleaned.to_csv("rescue_acc_bus_trip_toyosu2018.csv", index = False, encoding = "shift-jis")
