# -*- coding: utf-8 -*-
"""
Created on Tue Sep 17 16:16:46 2019

@author: Ikeda Kenji
"""

import pandas as pd
import os
import numpy as np
import matplotlib.pyplot as plt


pattern_count_threshold = 10


os.chdir(r"D:\夏の学校2019")

df = pd.read_csv("v2_trip_toyosu2018_idokeido.csv", encoding = "shift-JIS")

df2 = df[df["出発地施設緯度（世界測地系）"] != 0]

df3 = df2.fillna(-999)

df3 = df3.reset_index(drop = True)

shudan_list = {"バス": "B", "鉄道": "T", "モノレール": "T", "路面電車": "T", "地下鉄": "T", \
               "乗用車":"C" , "タクシー":"X" , "自転車":"b" , "シェアサイクル":"S" , "徒歩":"W" }

      
    

#df3["test_name"] = np.vectorize(okikae)(df3["移動手段変更1_名称"])
#df3["test_name"] = map(okikae, df3["移動手段変更1_名称"])
 

result_list = []
del_row_list = []

for key, row in df3.iterrows():
    
    tmp_list = []
    
    for i in list(row[15::3]):
        
        if i in shudan_list.keys():
            
            if (len(tmp_list) != 0):
                
                if (tmp_list[-1] != shudan_list[i]):
            
                    tmp_list.append(shudan_list[i]) 
                    
            else:
                
                tmp_list.append(shudan_list[i])
            
        elif i == -999:
            
            break
            
        else:
            
            del_row_list.append(key)
            
            break
            
    result_list.append(''.join(tmp_list)) 
    
    
    
df3["trip_pattern"] = result_list

df4 = df3.drop(df3.index[del_row_list])

trip_pattern = df4["trip_pattern"].value_counts()

tmp_del_trip_pattern_list = list(trip_pattern[trip_pattern <= pattern_count_threshold].index)

del_trip_pattern_list = [x for x in tmp_del_trip_pattern_list if (("X" not in x)&("S" not in x))]

remain_trip_pattern_list = list(set(trip_pattern.index)-set(del_trip_pattern_list))

#print(len(df3))
#
#print(len(df5))

#print(len(trip_pattern)-len(del_trip_pattern_list))

df5 = df4[~df4["trip_pattern"].isin(del_trip_pattern_list)]

df6 = df5[~(df5["walk_ttime"] == -9999)]

df7 = df6[df6["distance"] > 10]

df7 = df7.reset_index(drop = True)



walk_bicycle_ttime_del_row_list = []

for key,row in df7.iterrows():
    
    if row["移動手段"] == "自転車":
        
        threshold_value = row["トリップ時間_秒"]/(row["walk_ttime"]*60)
        
    elif row["移動手段"] == "徒歩":
        
        threshold_value = row["トリップ時間_秒"]/(row["walk_ttime"]*60)
        
    else:
        
        threshold_value = 1
        
    if ((threshold_value < 0.5) | (threshold_value > 2.0)):
        
        walk_bicycle_ttime_del_row_list.append(key)


df8 = df7.drop(df7.index[walk_bicycle_ttime_del_row_list])

 
df_walk = df7[df7["移動手段"] == "徒歩"]
df_walk_clean = df8[df8["移動手段"] == "自転車"]

plt.scatter(df_walk["トリップ時間_秒"], (df_walk["walk_ttime"]*60))
plt.scatter(df_walk_clean["トリップ時間_秒"], (df_walk_clean["bicycle_ttime"]*60))

#df8.to_csv("walk_cleaned_trip_toyosu2018.csv", index = False, encoding = "shift-jis")
   
#DF = pd.Series(result_list)
#
#DF2 = DF.drop(DF.index[del_row_list])

#trip_pattern = DF2.value_counts()

#valid_trip_pattern = trip_pattern[trip_pattern >= pattern_count_threshold]

#valid_trip_pattern.to_csv("valid_trip_pattern.csv", encoding = "shift-JIS")
    
   
df9 = pd.read_csv(r'car_trip_toyosu2018.csv', engine = "python")

df10 = df9[~(df9["car_ttime"] == -9999)]

df11 = df10[df10["car_distance"] > 30]

df11 = df11.reset_index(drop = True)

car_taxi_ttime_del_row_list = []

for key,row in df11.iterrows():
    
    if row["移動手段"] == "乗用車":
        
        threshold_value = row["トリップ時間_秒"]/(row["car_ttime"]*60)
        
    elif row["移動手段"] == "タクシー":
        
        threshold_value = row["トリップ時間_秒"]/(row["car_ttime"]*60)
        
    else:
        
        threshold_value = 1
        
    if ((threshold_value < 0.5) | (threshold_value > 2.0)):
        
        car_taxi_ttime_del_row_list.append(key)


df12 = df11.drop(df11.index[car_taxi_ttime_del_row_list])

#df_car_clean = df12[df12["移動手段"] == "タクシー"]
#
#plt.scatter(df_car_clean["トリップ時間_秒"], (df_car_clean["car_ttime"]*60))

#df12.to_csv("car_cleaned_trip_toyosu2018.csv", encoding = "shift-jis", index = False)


data01 = pd.read_csv("1_5000_train_trip_toyosu2018.csv", encoding = "shift-JIS")
data02 = pd.read_csv("5000_train_trip_toyosu2018.csv", encoding = "shift-JIS")

df13 = pd.concat([data01,data02])


df14 = df13[~(df13["train_ttime"] == -9999)]

#df15 = df14[~(df14["train_ttime"] == -999)]

df15 = df14.reset_index(drop = True)

df15["train_ttime_all"] = df15["acc_walk_ttime"]+df15["egr_walk_ttime"]+df15["train_ttime"]

train_ttime_del_row_list = []

for key,row in df15.iterrows():
    
    if ((row["移動手段"] == "鉄道") | (row["移動手段"] == "モノレール") |\
        (row["移動手段"] == "路面電車") |(row["移動手段"] == "地下鉄")):
        
        threshold_value = row["トリップ時間_秒"]/(row["train_ttime_all"]*60)###変える###
        
     
    else:
        
        threshold_value = 1
        
    if ((threshold_value < 0.5) | (threshold_value > 2.0)):
        
        train_ttime_del_row_list.append(key)
        
df16 = df15.drop(df15.index[train_ttime_del_row_list])

#df_train_clean = df16[df16["移動手段"] == "路面電車"]
#
#plt.scatter(df_train_clean["トリップ時間_秒"], (df_train_clean["train_ttime_all"]*60))

df16.to_csv("train_after_cleaning.csv",encoding = "shift-JIS", index = None)


###バス###
data03 = pd.read_csv("", encoding = "shift-JIS")
data04 = pd.read_csv("", encoding = "shift-JIS")

df17 = pd.concat([data03,data04])















 
   