# -*- coding: utf-8 -*-
"""
Created on Thu Jun 14 16:17:29 2018

@author: Yasushi
"""


"""
WARNING!!!!

この関数を高頻度（一秒に一回以上）で使用すると，サーバーに高負荷がかかり，警察に捕まる可能性もあるので，適度な間隔を設定して使用するようにしてください
参考:http://ascii.jp/elem/000/001/177/1177656/


引数
・外部モジュールrobobrowserで作成したbrowser
・出発地（駅名or住所）
・到着地（駅名or住所）
・その他入力値（下の入力フォーム一覧参照）

出力値
・乗車時間（アクセスイグレス歩行時間は無視）
・料金
・出発駅
・到着駅


参考：yahoo乗り換え入力フォーム一覧

from   : 出発
関数の中ではorigin
to     : 到着
関数の中ではdest
via    : 経由
y      : 年
m      : 月
d      : 日
hh     : 時間
Yahoo乗り換えでは「分」までは指定できない(?)

type   : 出発[1:デフォルト]，到着[4]，始発[3]，終電[2]，指定なし[5]
関数の中ではty（デフォルトを5に設定）

ticket : 種別     : ICカード優先[ic:デフォルト]，現金（きっぷ）優先[normal]
expkind: 座席     : 自由席優先[1:デフォルト]，指定席優先[2]，グリーン車優先[3]
ws     : 歩く速度  :　急いで[1]，少し急いで[2]，少しゆっくり[3:デフォルト]，ゆっくり[4]
s      : 表示順序 : 到着が早い順[0:デフォルト]，乗り換え回数順[2]，料金が安い順[1]

手段（利用する場合は1:デフォルト，利用しない場合は0）
関数の中では利用しない0をデフォルトとする
al     : 空路
shin   : 新幹線
ex     : 有料特急
hb     : 高速バス
lb     : 路線\連絡バス
sr     : フェリー

"""

#import robobrowser
import time
import pandas as pd
import numpy as np
from robobrowser import RoboBrowser
import os
os.chdir(r"C:\Users\Ikeda Kenji\Desktop\夏の学校2019\rescue")

browser = RoboBrowser()

def yahoo_transit(browser, origin, dest, hour, minute, year=2019, month=10, day=21):
    ##yahoo乗り換えのサイトへ
    browser.open("https://www.navitime.co.jp/bustransit/")
    ##フォームの取得
    form = browser.get_form(action="/bustransit/search")
    #＃フォームの書き換え
    form["orvStationName"] = origin
    form["dnvStationName"]   = dest
    form["hour"]   = hour
    form["minute"]   = minute

#    if al == 0:
#        form["al"].remove("1")
#    if shin == 0:
#        form["shin"].remove("1")
#    if ex == 0:
#        form["ex"].remove("1")
#    if hb == 0:
#        form["hb"].remove("1")
#    if lb == 0:
#        form["lb"].remove("1")
#    if sr == 0:
#        form["sr"].remove("1")
    ##フォームの送信
    browser.submit_form(form)
    ##最寄り駅が検出できなかった場合（-1，-1）を返す
    error = browser.select("div.message-area")                       
    if bool(error):
        t = -1
        c = -1
#        st1 = -1
#        st2 = -1
    else:
        ##所要時間
        t = list(browser.select("#route-1 div div dl dd")[0].strings)[0]
        t = list(map(int, t.replace("分", "").split("時間")))
        if len(t) == 1:
            t = t[0]
        elif len(t) == 2:
            t = t[0]*60 + t[1]
        ##料金
        c = int(list(browser.select("#route-1 div ul.fare-info li dl dd span.normal-fare")[0].strings)[0].replace(",",""))
#        c = int(c.replace(",", "").replace("円", ""))
        ##発着駅
#        st1 = list(browser.select("#route01 div.station dt a")[0].strings)[0]
#        st2 = list(browser.select("#route01 div.station dt a")[-1].strings)[0]
    return t, c

#ori = "兵庫県神戸市灘区六甲台町1-1" #神戸大学工学部
#origin = "徳井" #神戸大学工学部
#dest = "将軍通"

#os.chdir(r"C:\Users\Ikeda Kenji\Desktop\夏の学校2019")
df = pd.read_csv("rescur_egr_acc_bus_trip_toyosu2018.csv",encoding = "shift-JIS")

short_df = df

time_list = []
fare_list = []

index_error_list = []

#short_df = short_df[580:590]


for key,row in short_df.iterrows():
    time.sleep(1.0)
    origin = row["dep_bus_name"]
    
    dest = row["dest_bus_name"]
    
    hour = str(int(row["出発日付"].split(" ")[-1].split(":")[0]))
    
    minute = str(int(row["出発日付"].split(" ")[-1].split(":")[1]))
#    print(dep)
#    print(dest)
    try:
        
        a = yahoo_transit(browser, origin, dest, hour, minute, year=2019, month=10, day=21)
        
    except IndexError:
        
        index_error_list.append(key)
        
        a = (-1,-1)
        
        
        
        
    time_list.append(a[0])
    fare_list.append(a[1])
    

short_df["bus_ttime"] = time_list
short_df["bus_cost"] = fare_list


short_df.to_csv("rescue_bus_trip_toyosu2018.csv", encoding = "shift-JIS", index = None)

    
train_only_DF = pd.DataFrame({"bus_ttime":time_list, "bus_cost":fare_list})
train_only_DF.to_csv("rescue_bus.csv", encoding = "shift-JIS", index = None)

error_key_series = pd.Series(index_error_list)
error_key_series.to_csv("rescue_index_error_key_list.csv", index = False)

