# -*- coding: utf-8 -*-
"""
Created on Thu Jun 14 16:17:29 2018

@author: Yasushi
"""


"""
WARNING!!!!

この関数を高頻度（一秒に一回以上）で使用すると，サーバーに高負荷がかかり，警察に捕まる可能性もあるので，適度な間隔を設定して使用するようにしてください
参考:http://ascii.jp/elem/000/001/177/1177656/


引数
・外部モジュールrobobrowserで作成したbrowser
・出発地（駅名or住所）
・到着地（駅名or住所）
・その他入力値（下の入力フォーム一覧参照）

出力値
・乗車時間（アクセスイグレス歩行時間は無視）
・料金
・出発駅
・到着駅


参考：yahoo乗り換え入力フォーム一覧

from   : 出発
関数の中ではorigin
to     : 到着
関数の中ではdest
via    : 経由
y      : 年
m      : 月
d      : 日
hh     : 時間
Yahoo乗り換えでは「分」までは指定できない(?)

type   : 出発[1:デフォルト]，到着[4]，始発[3]，終電[2]，指定なし[5]
関数の中ではty（デフォルトを5に設定）

ticket : 種別     : ICカード優先[ic:デフォルト]，現金（きっぷ）優先[normal]
expkind: 座席     : 自由席優先[1:デフォルト]，指定席優先[2]，グリーン車優先[3]
ws     : 歩く速度  :　急いで[1]，少し急いで[2]，少しゆっくり[3:デフォルト]，ゆっくり[4]
s      : 表示順序 : 到着が早い順[0:デフォルト]，乗り換え回数順[2]，料金が安い順[1]

手段（利用する場合は1:デフォルト，利用しない場合は0）
関数の中では利用しない0をデフォルトとする
al     : 空路
shin   : 新幹線
ex     : 有料特急
hb     : 高速バス
lb     : 路線\連絡バス
sr     : フェリー

"""

import robobrowser
from robobrowser import RoboBrowser
import pandas as pd
import os
import numpy as np
import time

browser = RoboBrowser()

def yahoo_transit(browser, origin, dest, ty=5, al=0, shin=0, ex=0, hb=0, lb=0, sr=0):
    
    if origin == dest:
        t2 = -999
        c = -999
        st1 = -999
        st2 = -999

    else:
        
    ##yahoo乗り換えのサイトへ
        browser.open("https://transit.yahoo.co.jp/")
        ##フォームの取得
        form = browser.get_form(action = "/search/result")
        #＃フォームの書き換え
        form["from"] = origin
        form["to"]   = dest
        form["type"] = str(ty)
        if al == 0:
            form["al"].remove("1")
        if shin == 0:
            form["shin"].remove("1")
        if ex == 0:
            form["ex"].remove("1")
        if hb == 0:
            form["hb"].remove("1")
        if lb == 0:
            form["lb"].remove("1")
        if sr == 0:
            form["sr"].remove("1")
        ##フォームの送信
        browser.submit_form(form)
        ##最寄り駅が検出できなかった場合（-1，-1）を返す
        error = browser.select("#error-text")                       
        if bool(error):
            t2 = -999
            c = -999
            st1 = -999
            st2 = -999
        else:
            ##所要時間
            t = list(browser.select("#route01 li.time")[0].strings)[0][:-1]
            
            if t == '[!':
                t2 = -999
                c = -999
                st1 = -999
                st2 = -999
                
    #        print(t)
            else:
                
                t2 = list(map(int, t.split("時間")))
        #        print(t2)
                if len(t2) == 1:
                    t2 = t2[0]
                elif len(t2) == 2:
                    t2 = t2[0]*60 + t2[1]
                ##料金
                c = list(browser.select("#route01 li.fare")[0].strings)[-1]
                c = int(c.replace(",", "").replace("円", ""))
                ##発着駅
                st1 = list(browser.select("#route01 div.station dt a")[0].strings)[0]
                st2 = list(browser.select("#route01 div.station dt a")[-1].strings)[0]
    return t2, c, st1, st2


os.chdir(r"C:\Users\Ikeda Kenji\Desktop\夏の学校2019")
df = pd.read_csv("egr_acc_nearby_trip_toyosu2018.csv",encoding = "shift-JIS")

short_df = df.iloc[0:5000,:]

time_list = []
fare_list = []
ori_list = []
des_list = []

for key,row in short_df.iterrows():
    time.sleep(1.0)
    ori = row[68]
    
    des = row[78]
#    print(dep)
#    print(dest)
    a = yahoo_transit(browser, ori, des, ty=5, al=0, shin=0, ex=0, hb=0, lb=1, sr=0)
    time_list.append(a[0])
    fare_list.append(a[1])
    ori_list.append(a[2])
    des_list.append(a[3])

short_df["train_ttime"] = time_list
short_df["train_cost"] = fare_list

short_df.to_csv("1_5000_train_trip_toyosu2018.csv", encoding = "shift-JIS", index = None)

    
train_only_DF = pd.DataFrame({"train_ttime":time_list, "train_cost":fare_list})
train_only_DF.to_csv("train.csv", encoding = "shift-JIS", index = None)
#ori = "兵庫県神戸市灘区六甲台町1-1" #神戸大学工学部
#ori = "兵庫県神戸市灘区宮山町3-1" #神戸大学工学部
#des = "兵庫県神戸市中央区三宮町1丁目5-8"


