# -*- coding: utf-8 -*-
"""
Created on Wed Sep 18 14:05:16 2019

@author: kazuya
"""

import urllib.request, json
import urllib.parse
import datetime
import pandas as pd
import numpy as np

#Google Maps Platform Directions API endpoint
endpoint = 'https://maps.googleapis.com/maps/api/directions/json?'
api_key = ''



mode = "walking"

#origin = '34.694891,135.1945652'
#destination = '34.6866248,135.1818114'
#dep_time = "2019/09/18 16:45:30"

def change_strtime(datetime_str):
    
    date = datetime_str.split(" ")[0]
    time = datetime_str.split(" ")[-1]
    
#    year  = date.split("/")[0]
    month = date.split("/")[1].zfill(2)
    day   = date.split("/")[2].zfill(2)
    
    hour    = time.split(":")[0].zfill(2)
    minutes = time.split(":")[-1].zfill(2)
    
    str_datetime_date = "2020/{0}/{1} {2}:{3}:00".format(month, day, hour, minutes)
    

    return str_datetime_date

    


def get_ttime(mode, origin, destination, dep_time):

    #UNIX時間の算出
    dtime = datetime.datetime.strptime(dep_time, '%Y/%m/%d %H:%M:%S')
    #dtime = dtime + datetime.timedelta(hours=9)
    #print(dtime.timestamp())
    unix_time = int(dtime.timestamp())
    
    #print('')
    #print('=====')
    #print('unixtime')
    #print(unix_time)
    #print('=====')
    
    nav_request = 'language=ja&origin={}&mode={}&destination={}&departure_time={}&key={}'.format(origin,mode,destination,unix_time,api_key)
    nav_request = urllib.parse.quote_plus(nav_request, safe='=&')
    request = endpoint + nav_request
    
    #print('')
    #print('=====')
    #print('url')
    #print(request)
    #print('=====')
    
    #Google Maps Platform Directions APIを実行
    response = urllib.request.urlopen(request).read()
    
    #結果(JSON)を取得
    directions = json.loads(response)
    
    #所要時間を取得
    for key in directions['routes']:
        #print(key) # titleのみ参照
        #print(key['legs']) 
        for key2 in key['legs']:
#            print('')
#            print('=====')
#            print(key2['distance']['text'])
#            print(key2['duration']['text'])
#            print('=====')
        
            result_ttime = key2['duration']['value'] / 60
            
            result_distance = key2['distance']['value']
            
            result_bike_ttime = ((result_distance/1000) / 12) * 60
            
            

    return result_ttime, result_distance, result_bike_ttime



#def make_df_ttime(orig_lon, orig_lat, dist_lon, dist_lat, dep_time_row):
#
#    #出発地、目的地を入力
#    origin = str(orig_lat) + "," + str(orig_lon)
#    
#    destination = str(dist_lat) + "," + str(dist_lon)
#    
#    dep_time = str(dep_time_row)
#    
#    result_ttime1, result_distance1, result_bike_ttime1 = get_ttime(mode, origin, destination, dep_time)
#    
#    return result_ttime1, result_distance1, result_bike_ttime1




import time

start = time.time()

df = pd.read_csv(r"trip_toyosu2018_idokeido.csv", engine = "python")
    
df["出発日付"] = list(map(change_strtime, df["出発日付"]))

#ttime, distance, bike_ttime = np.vectorize(make_df_ttime)(df["出発地施設経度（世界測地系）"], df["出発地施設緯度（世界測地系）"], df["到着地施設経度（世界測地系）"], df["到着地施設緯度（世界測地系）"], df["出発日付"])
    
    
#end = time.time()
#
#print(end-start)   

    
result_ttime1_list = []    
result_distance1_list = []
result_bike_ttime1_list = []
error_key_list = []
    
for key,row in df.iterrows():

    #出発地、目的地を入力
    origin = str(row["出発地施設緯度（世界測地系）"]) + "," + str(row["出発地施設経度（世界測地系）"])
    
    destination = str(row["到着地施設緯度（世界測地系）"]) + "," + str(row["到着地施設経度（世界測地系）"])
    
    dep_time = str(row["出発日付"])
    
    try:
    
        result_ttime1, result_distance1, result_bike_ttime1 = get_ttime(mode, origin, destination, dep_time)
        
    except UnboundLocalError:
        
        result_ttime1, result_distance1, result_bike_ttime1 = (-9999, -9999, -9999)
        
        error_key_list.append(key)
        
    
    result_ttime1_list.append(result_ttime1)
    result_distance1_list.append(result_distance1)
    result_bike_ttime1_list.append(result_bike_ttime1)
    
    
end = time.time()

print(end-start) 


df["walk_ttime"] = result_ttime1_list

df["distance"] = result_distance1_list

df["bicycle_ttime"] = result_bike_ttime1_list

#df.to_csv("v2_trip_toyosu2018_idokeido.csv", index = False, encoding = "shift-jis")


result_DF = pd.DataFrame(np.array([df["トリップID"].values,df["ユーザーコード"].values,result_ttime1_list,result_distance1_list,result_bike_ttime1_list]).T,
                         columns = ["トリップID","ユーザーコード","walk_ttime","distance","bicycle_ttime"])

#result_DF.to_csv("walk_bycycle.csv", index = False, encoding = "shift-jis")
    
    
error_key_series = pd.Series(error_key_list)
#error_key_series.to_csv("walk_error_key_list.csv", index = False)
