# -*- coding: utf-8 -*-
"""
Created on Fri Sep 20 07:00:40 2019

@author: Ikeda Kenji
"""

import pandas as pd
import os
import googlemaps
import numpy as np

gmaps = googlemaps.Client(key='')###key変える

os.chdir(r"E:\rescue")


def get_duration(dest_lat, dest_lng):
    

    # 住所から緯度経度を取得する
#    geocode_result = gmaps.geocode(lat, lon)
#    dest_lat = geocode_result[0]['geometry']['location']['lat'] # 緯度
#    dest_lng = geocode_result[0]['geometry']['location']['lng'] # 経度

    # 最寄り駅の緯度経度を取得
    places_result = gmaps.places_nearby(location=(dest_lat, dest_lng),rank_by='distance', keyword = '\u5171\u6709\u81ea\u8ee2\u8eca\u30b9\u30c6\u30fc\u30b7\u30e7\u30f3', language = 'ja')
    dep_lat = places_result['results'][0]['geometry']['location']['lat'] # 緯度
    dep_lng = places_result['results'][0]['geometry']['location']['lng'] # 経度
    
    station_name = places_result['results'][0]['name']

    # 所要時間の取得
    walk_duration_result = gmaps.distance_matrix(origins=(dep_lat, dep_lng), destinations=(dest_lat, dest_lng),
                                            mode='walking')
    walk_duration = walk_duration_result['rows'][0]['elements'][0]['duration']['value'] / 60
    walk_distance = walk_duration_result['rows'][0]['elements'][0]["distance"]["value"]
    
#    bicycle_duration = ((walk_distance/1000) / 12) * 60
#    
#    car_duration_result = gmaps.distance_matrix(origins=(dep_lat, dep_lng), destinations=(dest_lat, dest_lng),
#                                            mode='driving')
#    car_duration = car_duration_result['rows'][0]['elements'][0]['duration']['value'] / 60
#    car_distance = car_duration_result['rows'][0]['elements'][0]["distance"]["value"]
#    
#    if car_distance <= 1052:               
#        result_taxi_cost = 410                 
#    else:        
#        result_taxi_cost = 410 + (int((car_distance - 1052) / 237) + 1) * 80 
        
    address_result = gmaps.reverse_geocode((dep_lat, dep_lng), language = "ja")    
    address = address_result[0]["formatted_address"].split(" ")[-1]
    
    return dep_lat, dep_lng, station_name, address, walk_duration, walk_distance



#dep_lat, dep_lng, station_name, address, walk_duration, walk_distance, bicycle_duration, car_duration, car_distance, result_taxi_cost = get_duration(34.726478, 135.237911)


df_car_cleaned_with_acc = pd.read_csv("rescue_acc_sharebike_trip_toyosu2018.csv", engine = "python", encoding = "shift-JIS")

import time

start = time.time()


result_dep_lat_list = []    
result_dep_lng_list = []
result_station_name_list = []
result_address_list = []    
result_walk_duration_list = []
result_walk_distance_list = []
#result_bicycle_duration_list = []    
#result_car_duration_list = []
#result_car_distance_list = []
#result_taxi_cost_list = []
error_key_list = []

UnboundLocalError_count = 0
KeyError_count = 0
IndexError_count = 0
    
for key,row in df_car_cleaned_with_acc.iterrows():

    #出発地、目的地を入力
    dest_lat = str(row["到着地施設緯度（世界測地系）"])
    
    dest_lng = str(row["到着地施設経度（世界測地系）"])
    
    try:
    
        dep_lat, dep_lng, station_name, address, walk_duration, walk_distance = get_duration(dest_lat, dest_lng)
        
    except UnboundLocalError:
        
        dep_lat, dep_lng, station_name, address, walk_duration, walk_distance = (-9999, -9999, -9999,-9999, -9999, -9999)
        
        error_key_list.append(key)
        
        UnboundLocalError_count += 1
        
    except KeyError:
        
        dep_lat, dep_lng, station_name, address, walk_duration, walk_distance = (-9999, -9999, -9999,-9999, -9999, -9999)
        
        error_key_list.append(key)
        
        KeyError_count += 1
        
    except IndexError:
        
        dep_lat, dep_lng, station_name, address, walk_duration, walk_distance = (-9999, -9999, -9999,-9999, -9999, -9999)
        
        error_key_list.append(key)
        
        IndexError_count += 1
        
    
    result_dep_lat_list.append(dep_lat)
    result_dep_lng_list.append(dep_lng)
    result_station_name_list.append(station_name)
    result_address_list.append(address)   
    result_walk_duration_list.append(walk_duration)
    result_walk_distance_list.append(walk_distance)
#    result_bicycle_duration_list.append(bicycle_duration)    
#    result_car_duration_list.append(car_duration)
#    result_car_distance_list.append(car_distance)
#    result_taxi_cost_list.append(result_taxi_cost)
#    
      
    
end = time.time()

print(end-start) 


df_car_cleaned_with_acc["dest_sharebike_lat"] = result_dep_lat_list
df_car_cleaned_with_acc["dest_sharebike_lon"] = result_dep_lng_list
df_car_cleaned_with_acc["dest_sharebike_name"] = result_station_name_list
df_car_cleaned_with_acc["dest_sharebike_address"] = result_address_list
df_car_cleaned_with_acc["egr_sharebike_walk_ttime"] = result_walk_duration_list
df_car_cleaned_with_acc["egr_sharebike_walk_distance"] = result_walk_distance_list
#df_car_cleaned_with_acc["egr_bus_bicycle_ttime"] = result_bicycle_duration_list
#df_car_cleaned_with_acc["egr_bus_car_ttime"] = result_car_duration_list
#df_car_cleaned_with_acc["egr_bus_car_distance"] = result_car_distance_list
#df_car_cleaned_with_acc["egr_bus_taxi_cost"] = result_taxi_cost_list


df_car_cleaned_with_acc.to_csv("rescue_egr_acc_sharebike_trip_toyosu2018.csv", index = False, encoding = "cp932")


result_DF = pd.DataFrame(np.array([result_dep_lat_list, result_dep_lng_list, result_station_name_list, result_address_list, result_walk_duration_list,
                                   result_walk_distance_list]).T,
                         columns = ["dest_sharebike_lat","dest_sharebike_lon","dest_sharebike_name","dest_sharebike_address","egr_sharebike_walk_ttime",
                                    "egr_sharebike_walk_distance"])

result_DF.to_csv("rescue_egr_sharebike.csv", index = False, encoding = "shift-jis")
    
    
error_key_series = pd.Series(error_key_list)
error_key_series.to_csv("rescue_egr_sharebike_error_key_list.csv", index = False)






copy_df_car_cleaned = df_car_cleaned_with_acc.copy()
def name_change(name):
    if type(name) == int:
        print(name)
        
    
    elif "－" in name:
        name = name.replace("－"," ") 
        
    elif "Ⅰ" in name:
        name = name.replace("Ⅰ","1")
        
    elif "②" in name:
        name = name.replace("②","2")
        
    elif "－" in name:
        name = name.replace("－"," ")
    
    return name

copy_df_car_cleaned["dep_sharebike_name"] = list(map(name_change, copy_df_car_cleaned["dep_sharebike_name"]))
#
#dfdfdf = copy_df_car_cleaned[218:]
##
#dfdfdf.to_csv("dfdfdf_acc_bus_trip_toyosu2018.csv", index = False, encoding = "shift-jis")
#
copy_df_car_cleaned.to_csv("check.csv", index = False, encoding = "shift-jis")
